function tipController($http, $window, $scope, $timeout, $anchorScroll, $animate, $location, tipService, lookupService) {
    var vm = this;
    vm.scope = $scope;
    vm.tipService = tipService;
    vm.lookupService = lookupService
    vm.crimeType = -1;
    vm.newRecordId = -1;
    vm.fileUploadedSuccessfully = false;
    vm.isSubmitted = false;
    vm.isSubmissionInProgress = false;
    vm.document = { mime: null, fileName: null, content: null },
    vm.pptFraudType = function (fraudType) {
        if(angular.isDefined(fraudType)) {
            vm.tipService.passportTipModel.pptFraudType = fraudType;
            vm.isSubmitted = false;
            if(angular.isDefined(vm.fraudTipForm)) {
                vm.fraudTipForm.$setPristine();
                vm.fraudTipForm.$setUntouched();
            }
        }
        else {
            return vm.tipService.passportTipModel.pptFraudType
        }
    }
    if (window.location.search.indexOf('testmode') != -1) {
        vm.tipService.loadTestData();
    }
        
    
    vm.pptFraudTypeAsString = function (fraudType) {
        var fraudTypeString = '';
        vm.lookupService.passportFraudTypeList.find(function (item) {
            if (item.value === fraudType) {
                fraudTypeString = item.title;
            }
        });
        return fraudTypeString;
    };
    vm.visaFraudTypeAsString = function (fraudType) {
        var fraudTypeString = '';
        vm.lookupService.visaFraudTypeList.find(function (item) {
            if (item.value === fraudType) {
                fraudTypeString = item.title;
            }
        });
        return fraudTypeString;
    };
    vm.humanTraffickingFraudTypeAsString = function (fraudType) {
        var fraudTypeString = '';
        vm.lookupService.humanTraffickingFraudTypeList.find(function (item) {
            if (item.value === fraudType) {
                fraudTypeString = item.title;
            }
        });
        return fraudTypeString;
    };
    vm.dateOfBirthAsString = function (year, month, day) {
        var monthName = '';
        vm.lookupService.monthList.find(function (item) {
            if (item.value === month) {
                monthName = item.title;
            }
        });
        return monthName + ' ' + day + ', ' + year;
    };
    vm.countryNameAsString = function (country) {
        var countryName = '';
        vm.lookupService.countryList.find(function (item) {
            if (item.value === country) {
                countryName = item.label;
            }
        });
        return countryName;
    };

    vm.submitPassportTipForm = function (fraudInformationForm) {
        vm.isSubmitted = true;
        if(tipService.passportTipModel.pptFraudType === '7' || tipService.passportTipModel.pptFraudType === '8') {
            //set non-required fields to null;
            tipService.complainantModel.isAnonymousComplainant = 'false';
            tipService.complainantModel.email = null;
            tipService.complainantModel.isUSLocation = null;
            tipService.complainantModel.streetAddress1 = null;
            tipService.complainantModel.streetAddress2 = null;
            tipService.complainantModel.city = null;
            tipService.complainantModel.state = null;
            tipService.complainantModel.zipCode = null;
            tipService.complainantModel.country = null;
        }
        //$anchorScroll('generalPassportFraud');
        if (fraudInformationForm.$valid) {
            var submitter = {};
            if (vm.tipService.complainantModel.isAnonymousComplainant === 'false') {
                submitter = vm.tipService.complainantModel;    
            }
            var crimeTip = vm.tipService.passportTipModel;
            postTipInformation(vm.tipService.passportTipModel.crimeType, submitter, crimeTip, vm);
        }
        else {
            console.log('form is not valid');
            //angular.element('input.ng-invalid').first().focus();
            focusOnInvalidElement();
        }
    };

    function focusOnInvalidElement() {
        var elt = $(".ng-invalid");
        if (elt.length) {
            $('html, body').animate({
                scrollTop: (elt.first().offset().top)
            }, 500);
        }
    }
    vm.submitVisaTipForm = function (fraudInformationForm) {
        vm.isSubmitted = true;
        if (fraudInformationForm.$valid) {
            var submitter = {};
            if (vm.tipService.complainantModel.isAnonymousComplainant === 'false') {
                submitter = vm.tipService.complainantModel;
            }


            var crimeTip = vm.tipService.visaTipModel;
            postTipInformation(vm.tipService.visaTipModel.crimeType, submitter, crimeTip, vm);
        }
        else {
            console.log('form is not valid');
            focusOnInvalidElement();
        }
    };
    vm.submitMalfeasanceTipForm = function (fraudInformationForm) {
        vm.isSubmitted = true;

        if (fraudInformationForm.$valid) {
            var submitter = {};
            if (vm.tipService.complainantModel.isAnonymousComplainant === 'false') {
                submitter = vm.tipService.complainantModel;
            }

            var crimeTip = vm.tipService.malfeasanceTipModel;
            postTipInformation(vm.tipService.malfeasanceTipModel.crimeType, submitter, crimeTip, vm);
        }
        else {
            console.log('form is not valid');
            focusOnInvalidElement();
        }
    };
    vm.submithumanTraffickingTipForm = function (fraudInformationForm) {
        vm.isSubmitted = true;
        if (fraudInformationForm.$valid) {
            var submitter = {};
            if (vm.tipService.complainantModel.isAnonymousComplainant === 'false') {
                submitter = vm.tipService.complainantModel;
            }

            var crimeTip = vm.tipService.humanTraffickingTipModel;
            postTipInformation(vm.tipService.humanTraffickingTipModel.crimeType, submitter, crimeTip, vm);
        }
        else {
            console.log('form is not valid');
            focusOnInvalidElement();
        }
    };
    vm.submitFugitiveTipForm = function (fraudInformationForm) {
        vm.isSubmitted = true;
        if (fraudInformationForm.$valid) {
            var submitter = {};
            if (vm.tipService.complainantModel.isAnonymousComplainant === 'false') {
                submitter = vm.tipService.complainantModel;
            }

            var crimeTip = vm.tipService.fugitiveTipModel;
            postTipInformation(vm.tipService.fugitiveTipModel.crimeType, submitter, crimeTip, vm);
        }
        else {
            console.log('form is not valid');
            focusOnInvalidElement();
        }
    };
    function postTipInformation(crimeType, submitter, crimeTip) {
        /* cr57f for xfinion, cr1f6 for dos ds-dv*/

        var dataForSubmit = JSON.stringify({
            crimetype: crimeType,
            submitter: JSON.stringify(submitter),
            tip: JSON.stringify(crimeTip),
            attachment: vm.document.content == null ? "" : vm.document.content,
            attachmentmime: vm.document.mime == null ? "" : vm.document.mime,
            attachmentfilename: vm.document.fileName == null ? "" : vm.document.fileName
        });
        console.log(dataForSubmit);
        vm.isSubmissionInProgress = true;

        /*
        webapi.safeAjax({
            type: "POST",
            url: "/_api/cr1f6_crimetips",
            contentType: "application/json",
            data: dataForSubmit,
            success: function (res, status, xhr) {
                var newRecordId = xhr.getResponseHeader("entityid")
                console.log(`recordId - ${newRecordId}`);
                vm.scope.$apply(() => {
                    vm.newRecordId = newRecordId;
                });
                //with the newRecordId, upload the image if it is present
                console.log(`new value of vm.newRecordId is ${vm.newRecordId}, uploading image now`)
                if (vm.document.fileName != null) {
                    var buffer = new Uint8Array(vm.document.content);
                    var attachmentName = vm.document.fileName;
                    var attachmentmime = vm.document.mime;

                    webapi.safeAjax({
                        url: "/_api/cr1f6_crimetips(" + vm.newRecordId + ")/cr1f6_evidence?x-ms-file-name=" + attachmentName,
                        type: "PATCH",
                        contentType: "application/octet-stream",
                        processData: false,
                        data: buffer,
                        // On success
                        success: function (xhr, status, error) {
                            vm.scope.$apply(() => {
                                vm.isSubmissionInProgress = false;
                                vm.fileUploadedSuccessfully = true;
                            });
                            console.log(`Image uploaded successfully`);
                        },
                        // On error
                        error: function (xhr, status, error) {
                            var errorMessage = xhr.status + ': ' + xhr.statusText;
                            alert("We encountered an error uploading the document. Your tip information was submitted successfully. Please try submitting the tip again.")
                            console.log('error submitting data ' + errorMessage);
                            vm.scope.$apply(() => {
                                vm.newRecordId = -1;
                                vm.isSubmissionInProgress = false;
                                vm.fileUploadedSuccessfully = false;
                            });
                        }
                    });
                    window.scrollTo({ top: 0, behavior: 'smooth' });
                }
                else {
                    vm.scope.$apply(() => {
                        vm.isSubmissionInProgress = false;
                    });
                }
                
            },
            error: function (xhr, status, error) {
                alert('There was an error submitting tip information, please try submitting again.')
                var errorMessage = xhr.status + ': ' + xhr.statusText;
                console.log('error submitting data - ' + JSON.stringify(errorMessage));
                vm.newRecordId = -1;
                vm.scope.$apply(() => {
                    vm.isSubmissionInProgress = false;
                });
            },
        });
        */
        
        $timeout(function() { 
            $http({
                method: 'POST',
                //url: 'https://webhook.site/crimeTipsTest',
                //url: 'https://prod-14.westus.logic.azure.com:443/workflows/39a281852d934833b5014f5c1ecaee93/triggers/manual/paths/invoke?api-version=2016-06-01&sp=%2Ftriggers%2Fmanual%2Frun&sv=1.0&sig=bVKGenyzupEheeljuf-phSTQ4ODJ1lqSIgHS90xPJpA',
                url: 'https://prod-10.usgovtexas.logic.azure.us:443/workflows/7a23b17e021241e08190f4498b8c170e/triggers/manual/paths/invoke?api-version=2016-06-01&sp=%2Ftriggers%2Fmanual%2Frun&sv=1.0&sig=d5GqesL69QBP15rEc2y4eW9jxSgI3Wj8ZWXyiswBO80',
                headers: {
                    'Content-Type': 'application/json'
                },
                data: dataForSubmit
            }).then(function successCallback(response) {
                vm.isSubmissionInProgress = false;
                console.log(`Data was successfully posted ${JSON.stringify(response) }`);
                vm.newRecordId = Math.floor(Date.now());
                window.scrollTo({ top: 0, behavior: 'smooth' });

            }, function errorCallback(response) {
                vm.isSubmissionInProgress = false;
                console.log(`There was an error posting data ${JSON.stringify(response)}`);
                vm.newRecordId = -1;
                alert('There was an error submitting tip information, please try submitting again.')
        
            });
        }, 2000);
        
    }
}